"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SensitiveInformation(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "gelID",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import participant as participant_1_4_0

        return {
            "versionControl": participant_1_4_0.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import participant as participant_1_4_0

        return {
            "org.gel.models.participant.avro.VersionControl": participant_1_4_0.VersionControl,
            "org.gel.models.participant.avro.SensitiveInformation": participant_1_4_0.SensitiveInformation,
        }

    __slots__ = [
        "gelID",
        "versionControl",
        "centerPatientId",
        "centerSampleId",
        "contactNumber",
        "externalIds",
        "fullNameOfResponsibleConsultant",
        "genomicMedicineCenter",
        "hospitalOfResponsibleConsultant",
        "originatingCenter",
    ]

    def __init__(
        self,
        gelID,
        versionControl,
        centerPatientId=None,
        centerSampleId=None,
        contactNumber=None,
        externalIds=None,
        fullNameOfResponsibleConsultant=None,
        genomicMedicineCenter=None,
        hospitalOfResponsibleConsultant=None,
        originatingCenter=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_4_0.SensitiveInformation model.

        :param gelID:
        :type gelID: str
        :param versionControl:
            Model version number
        :type versionControl: VersionControl
        :param centerPatientId:
        :type centerPatientId: None | str
        :param centerSampleId:
        :type centerSampleId: None | str
        :param contactNumber:
        :type contactNumber: None | str
        :param externalIds:
        :type externalIds: None | list[str]
        :param fullNameOfResponsibleConsultant:
        :type fullNameOfResponsibleConsultant: None | str
        :param genomicMedicineCenter:
        :type genomicMedicineCenter: None | str
        :param hospitalOfResponsibleConsultant:
        :type hospitalOfResponsibleConsultant: None | str
        :param originatingCenter:
        :type originatingCenter: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.4.0"
